

from machine import Pin, SoftI2C
from pico_i2c_lcd import I2cLcd
from time import sleep , ticks_us

# Define the LCD I2C address and dimensions
I2C_ADDR = 0x3f
I2C_NUM_ROWS = 2
I2C_NUM_COLS = 16
TRIG = Pin(3, Pin.OUT)
ECHO = Pin(2, Pin.IN)
# Initialize I2C and LCD objects
i2c = SoftI2C(sda=Pin(0), scl=Pin(1), freq=400000)
lcd = I2cLcd(i2c, I2C_ADDR, I2C_NUM_ROWS, I2C_NUM_COLS)

lcd.putstr("It's working :)")
sleep(1)
lcd.clear()
def get_distance():
    TRIG.low()
    sleep(0.002)
    TRIG.high()
    sleep(0.00001)
    TRIG.low()

    while ECHO.value() == 0:
        signaloff = ticks_us()
    while ECHO.value() == 1:
        signalon = ticks_us()

    time_passed = signalon - signaloff
    distance_cm = (time_passed * 0.0343) / 2
    return distance_cm



while True:
    
    distance = get_distance()
    
    lcd.move_to(0, 1)
    lcd.putstr("{:5.2f} cm     ".format(distance))
    sleep(0.5)
    lcd.move_to(0, 0)
    lcd.putstr("Distance:\n")
    sleep(1)



